summaryrefslogtreecommitdiffstats
path: root/libraries/libgbinder
diff options
context:
space:
mode:
author juanma19802024-01-18 01:46:34 +0100
committer Willy Sudiarto Raharjo2024-01-18 03:34:20 +0100
commit45d0cfce15688620ed8d864ea69a987e8bb508d9 (patch)
tree1d0488bd92afc6e3205394138566432547ac7ba8 /libraries/libgbinder
parent03d8ee780b22b2b4ac6622d64500e4e154327e9b (diff)
downloadslackbuilds-45d0cfce15688620ed8d864ea69a987e8bb508d9.tar.gz
libraries/libgbinder: Added (GLib-style interface to binder).
Signed-off-by: Willy Sudiarto Raharjo <willysr@slackbuilds.org>
Diffstat (limited to 'libraries/libgbinder')
-rw-r--r--libraries/libgbinder/README46
-rw-r--r--libraries/libgbinder/libgbinder.SlackBuild121
-rw-r--r--libraries/libgbinder/libgbinder.info10
-rw-r--r--libraries/libgbinder/slack-desc19
4 files changed, 196 insertions, 0 deletions
diff --git a/libraries/libgbinder/README b/libraries/libgbinder/README
new file mode 100644
index 0000000000..906e52647c
--- /dev/null
+++ b/libraries/libgbinder/README
@@ -0,0 +1,46 @@
+GLib-style interface to binder (Android IPC mechanism)
+
+Key features:
+
+1. Integration with GLib event loop
+2. Detection of 32 vs 64 bit kernel at runtime
+3. Asynchronous transactions that don't block the event thread
+4. Stable service manager and low-level transaction APIs
+
+Android keeps changing both low-level RPC and service manager
+protocols from version to version. To counter that, libgbinder
+implements configirable backends for different variants of those,
+and yet keeping its own API unchanged.
+
+Configuration is loaded from [Protocol] and [ServiceManager] sections
+of /etc/gbinder.conf file. The keys are binder device names or the
+special Default value, the value is the identifier of the protocol
+or service manager variant, respectively.
+
+In addition to reading /etc/gbinder.conf if it exists, /etc/gbinder.d
+directory is scanned for .conf files, the file list is sorted, files are
+loaded one by one, overwriting the entries loaded from /etc/gbinder.conf
+or from the previously processed file.
+
+Known protocol and service manager variants are aidl, aidl2, aidl3 and
+hidl. This list is expected to expand further in the future. The default
+configuration is as follows:
+
+ [Protocol]
+ Default = aidl
+ /dev/binder = aidl
+ /dev/hwbinder = hidl
+
+ [ServiceManager]
+ Default = aidl
+ /dev/binder = aidl
+ /dev/hwbinder = hidl
+
+Alternatively and preferably, one can specify the desired Android API
+level:
+
+ [General]
+ ApiLevel = 29
+
+and let libgbinder pick the appropriate preset. Full list of presets can
+be found in src/gbinder_config.c
diff --git a/libraries/libgbinder/libgbinder.SlackBuild b/libraries/libgbinder/libgbinder.SlackBuild
new file mode 100644
index 0000000000..570cb17051
--- /dev/null
+++ b/libraries/libgbinder/libgbinder.SlackBuild
@@ -0,0 +1,121 @@
+#!/bin/bash
+
+# Slackware build script for libgbinder
+
+# Copyright 2024 juanma1980 <juanma1980@disroot.org>
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+cd $(dirname $0) ; CWD=$(pwd)
+
+PRGNAM=libgbinder
+VERSION=${VERSION:-1.1.35}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+PKGTYPE=${PKGTYPE:-tgz}
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i586 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+if [ ! -z "${PRINT_PACKAGE_NAME}" ]; then
+ echo "$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE"
+ exit 0
+fi
+
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ "$ARCH" = "i586" ]; then
+ SLKCFLAGS="-O2 -march=i586 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+elif [ "$ARCH" = "aarch64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $PRGNAM
+tar zxvf $CWD/$PRGNAM-$VERSION.tar.gz
+cd ${PRGNAM}-${VERSION}
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
+ -o -perm 511 \) -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
+
+CFLAGS="$SLKCFLAGS"
+LIB=/usr/lib${LIBDIRSUFFIX}
+LIBDIR=$LIB make
+LIBDIR=$LIB make install-dev DESTDIR=$PKG
+
+rm -f $PKG/{,usr/}lib${LIBDIRSUFFIX}/*.la
+
+find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+
+cd $PKG
+
+# make all symbolic links relative
+# (code from https://unix.stackexchange.com/a/100955/16829)
+for link in $(find . -lname '/*'); do
+ target=$(readlink "$link")
+ link=${link#./}
+ echo "READ $link"
+ root=$(echo $link | sed -E 's|[^/](.[^/]*)|..|g'); root=${root#/}; root=${root%..}
+ echo "AS $root"
+ echo "LN $root${target#/}"
+ rm "$link"
+ echo $PWD
+ cd $(dirname link)
+ #The install creates a hard link with wrong path
+ #Dirty fix
+ target=${target/$PWD/}
+ ln -s "$root${target#/}" "$link"
+ cd $OLDPWD
+done
+rm -rf usr/share/doc
+rm -rf usr/share/man
+
+/sbin/makepkg -l y -c n -p $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE
diff --git a/libraries/libgbinder/libgbinder.info b/libraries/libgbinder/libgbinder.info
new file mode 100644
index 0000000000..cfc61c7ab2
--- /dev/null
+++ b/libraries/libgbinder/libgbinder.info
@@ -0,0 +1,10 @@
+PRGNAM="libgbinder"
+VERSION="1.1.35"
+HOMEPAGE="https://github.com/mer-hybris/libgbinder"
+DOWNLOAD="http://github.com/mer-hybris/libgbinder/archive/1.1.35/libgbinder-1.1.35.tar.gz"
+MD5SUM="6bdc0641856bfaaa3726f3df97f92375"
+DOWNLOAD_x86_64=""
+MD5SUM_x86_64=""
+REQUIRES="libglibutil"
+MAINTAINER="juanma1980"
+EMAIL="juanma1980@disroot.org"
diff --git a/libraries/libgbinder/slack-desc b/libraries/libgbinder/slack-desc
new file mode 100644
index 0000000000..3700fcd188
--- /dev/null
+++ b/libraries/libgbinder/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+libgbinder: libgbinder (short desc)
+libgbinder: GLib-style interface to binder (Android IPC mechanism)
+libgbinder:
+libgbinder:
+libgbinder:
+libgbinder:
+libgbinder:
+libgbinder:
+libgbinder:
+libgbinder:
+libgbinder: https://github.com/waydroid/gbinder-python